name: Regenerate Tutorials
on: [workflow_dispatch]

jobs:
  RegenerateTutorials:
    runs-on: ubuntu-latest
    steps:
    - name: Checkout
      uses: actions/checkout@v3

    - name: Clone Wiki
      uses: actions/checkout@v3
      with:
        repository: BelfrySCAD/BOSL2.wiki
        path: BOSL2.wiki

    - name: Apt Update
      run: sudo apt update

    - name: Install Required Libraries
      run: sudo apt-get install python3-pip python3-dev python3-setuptools python3-pil gifsicle libfuse2

    - name: Install OpenSCAD-DocsGen package.
      run: sudo pip3 install openscad-docsgen

    - name: Install OpenSCAD
      run: |
        cd $GITHUB_WORKSPACE
        wget https://github.com/openscad/openscad/releases/download/openscad-2021.01/OpenSCAD-2021.01-x86_64.AppImage
        sudo mv OpenSCAD-2021.01*-x86_64.AppImage /usr/local/bin/openscad
        sudo chmod +x /usr/local/bin/openscad

    - name: Tabs Check
      run: |
        cd $GITHUB_WORKSPACE
        ./scripts/check_for_tabs.sh

    - name: FooTest
      env:
        OPENSCADPATH: ${{ github.workspace }}/..
      run: echo $OPENSCADPATH

    - name: Generate Tutorials
      uses: GabrielBB/xvfb-action@v1.6
      env:
        OPENSCADPATH: ${{ github.workspace }}/..
      with:
        run: openscad-mdimggen -f

    - name: Upload Tutorials to Wiki
      uses: SwiftDocOrg/github-wiki-publish-action@v1
      with:
        path: "BOSL2.wiki"
      env:
        GH_PERSONAL_ACCESS_TOKEN: ${{ secrets.GH_PAT }}

